/*
 * Pan - A Newsreader for X
 * Copyright (C) 1999  Matt Eagleson (e.Messiah@superpimp.org)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */

#ifndef __NNTP_H__
#define __NNTP_H__

typedef struct _glist_c glist_c;
struct _glist_c {
	GSList *glist;
};

// articlelist download
typedef struct _alist_c alist_c;
struct _alist_c {
	GSList *alist;
};

// article download
typedef struct _ad_c ad_c;
struct _ad_c {
	queue_data *qdata;
	article_data *adata;
};

// article decode
typedef struct _adec_c adec_c;
struct _adec_c {
	queue_data *qdata;
	article_data *adata;
	char *filename;
	FILE *tmp;
};

// multipart decode
typedef struct _mdec_c mdec_c;
struct _mdec_c {
	queue_data *qdata;
	article_data *fadata;
	article_data *adata;
	char *filename;
	FILE *tmp;
	char **sd;
};


void disconnect (void);
void grouplist_download (void);
void articlelist_download (queue_data *);
void article_download (queue_data *);
void article_decode (queue_data *);
void multipart_decode (queue_data *);

void run_cleanup (int status);
int go_online (void);
int go_online_ask (void);
void go_offline (void);
void stop_all_mf(void);
void go_offline_mf(void);
void connect_wait (void);
void network_error (const gchar *, ...);
int set_group (group_data *data);
void article_post (queue_data *);
void nntp_send_noop(void);


#endif /* __NNTP_H__ */
